/* Ansteuerung der umgebauten Steckdosenleiste AP9212
 * Mit DDE-Automatierungsschnittstelle. Dienstname = APCDDE
 * heha, 150505
 */

#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>
#include <setupapi.h>
#include <devguid.h>

struct TConfig{
 POINTS WinPos;		// Fensterposition des Dialogs
 BYTE SerialNo;		// Nummer der seriellen Schnittstelle, 0 = COM1
 BYTE Relays;		// Relais-Status-Bits
}Config;

HINSTANCE hInstance;
HWND hMainWnd;
HANDLE hCom;
DWORD gDdeInst;
HSZ hszService;

#define elemof(x) (sizeof(x)/sizeof(*(x)))
#define T(x) TEXT(x)
#define nobreak

TCHAR MBoxTitle[64];

static int vMBox(HWND Wnd, UINT id, UINT style, va_list arglist) {
 TCHAR buf1[256],buf2[1024];
 LoadString(hInstance,id,buf1,elemof(buf1));
 wvnsprintf(buf2,elemof(buf2),buf1,arglist);
 return MessageBox(Wnd,buf2,MBoxTitle,style);
}

static int _cdecl MBox(HWND Wnd, UINT id, UINT style,...) {
 va_list va;
 va_start(va,style);
 return vMBox(Wnd,id,style,va);
}

static void SetCheckboxGroup(HWND Wnd, UINT u, UINT o, UINT bits) {
 for (;u<=o; u++) {
  CheckDlgButton(Wnd,u,bits&1);
  bits>>=1;
 }
}

static void SwitchRelays() {
 if (!hCom) {
  TCHAR ComName[10];
  wnsprintf(ComName,elemof(ComName),T("\\\\.\\COM%u"),Config.SerialNo+1);
  hCom=CreateFile(ComName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,0);
  if (hCom==INVALID_HANDLE_VALUE) {
   MBox(hMainWnd,1,MB_OK,ComName+4,GetLastError());
   return;
  }
/*
 DCB dcb;
 dcb.DCBlength=sizeof dcb;
 GetCommState(hCom,&dcb);
 dcb.fRtsControl=RTS_CONTROL_DISABLE;
 dcb.fDtrControl=DTR_CONTROL_DISABLE;
 SetCommState(hCom,&dcb);
*/ 
  bool ok=
     EscapeCommFunction(hCom,CLRBREAK)	// Ausgangszustand herstellen
   &&EscapeCommFunction(hCom,CLRDTR);
  if (!ok) {
   MBox(hMainWnd,2,MB_OK,Config.SerialNo+1,GetLastError());
   return;
  }
 }
 if (hCom==INVALID_HANDLE_VALUE) return;
 bool ok=true;
 for (BYTE m=0x80; m; m>>=1) {
  ok=ok
   &&EscapeCommFunction(hCom,Config.Relays&m?SETRTS:CLRRTS)	// Datenbit ausgeben
   &&EscapeCommFunction(hCom,SETDTR)	// Taktflanke
   &&EscapeCommFunction(hCom,CLRDTR);
 }
 ok=ok
  &&EscapeCommFunction(hCom,SETBREAK)	// Parallele bernahme
  &&EscapeCommFunction(hCom,CLRBREAK);
 if (!ok) MBox(hMainWnd,2,MB_OK,Config.SerialNo+1,GetLastError());
}

// Ldt Konfigurationsdaten aus Registrierung
static bool LoadConfig() {
 HKEY key;
 bool ok=false;
 if (!RegOpenKeyEx(HKEY_CURRENT_USER,T("Software\\h#s\\AP9212"),
   0,KEY_QUERY_VALUE,&key)) {
  DWORD size=sizeof(Config);
  if (!RegQueryValueEx(key,T("Config"),NULL,NULL,(LPBYTE)&Config,&size)
  && size==sizeof(Config)) ok=true;
  RegCloseKey(key);
 }
 return ok;
}

// Speichert Konfigurationsdaten in Registrierung
static bool SaveConfig() {
 HKEY key;
 if (RegCreateKeyEx(HKEY_CURRENT_USER,T("Software\\h#s\\AP9212"),
   0,NULL,REG_OPTION_NON_VOLATILE,KEY_SET_VALUE,NULL,&key,NULL)) return false;
 TCHAR s[256];
 RegSetValue(key,NULL,REG_SZ,s,LoadString(hInstance,0,s,elemof(s))*sizeof(TCHAR));
 RegSetValueEx(key,T("Config"),0,REG_BINARY,(LPBYTE)&Config,sizeof(Config));
 RegCloseKey(key);
 return true;
}

/***************
 * Haupfenster *
 ***************/
static INT_PTR CALLBACK MainDlgProc(HWND Wnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
 switch (Msg) {
  case WM_INITDIALOG: {
   hMainWnd=Wnd;
   GetWindowText(Wnd,MBoxTitle,elemof(MBoxTitle));
   if (LoadConfig()) {
    WINDOWPLACEMENT wp;
    wp.length=sizeof wp;
    GetWindowPlacement(Wnd,&wp);
    wp.rcNormalPosition.right-=wp.rcNormalPosition.left;
    wp.rcNormalPosition.bottom-=wp.rcNormalPosition.top;
    wp.rcNormalPosition.left=Config.WinPos.x;
    wp.rcNormalPosition.top=Config.WinPos.y;
    wp.rcNormalPosition.right+=wp.rcNormalPosition.left;
    wp.rcNormalPosition.bottom+=wp.rcNormalPosition.top;
    SetWindowPlacement(Wnd,&wp);
   }
   SendMessage(Wnd,WM_TIMER,1,0);
   SetCheckboxGroup(Wnd,16,23,Config.Relays);
   SwitchRelays();
  }return TRUE;
  
  case WM_COMMAND: switch (wParam) {
   case 1:
   case 2: EndDialog(Wnd,wParam); break;
   
   case MAKELONG(10,CBN_SELCHANGE): {
    CloseHandle(hCom);	// egal was drinsteht
    hCom=0;
    Config.SerialNo=(BYTE)ComboBox_GetItemData((HWND)lParam,ComboBox_GetCurSel((HWND)lParam));
    SwitchRelays();
   }break;

   default: if (wParam-16<8) {
    Config.Relays^=1<<(wParam-16);
    DdePostAdvise(gDdeInst,0,0);
    SwitchRelays();
   }
  }break;

  case WM_DEVICECHANGE: SetTimer(Wnd,1,1500,0); break;
  
  case WM_TIMER: {
   HWND hCombo;
   KillTimer(Wnd,wParam);
// serielle Schnittstellen (neu) listen (bei jedem WM_DEVICECHANGE bspw. fr USB)
   hCombo=GetDlgItem(Wnd,10);
   ComboBox_ResetContent(hCombo);
   HANDLE devs=SetupDiGetClassDevs(&GUID_DEVCLASS_PORTS,NULL,0,DIGCF_PRESENT);
   if (devs!=INVALID_HANDLE_VALUE) {
    SP_DEVINFO_DATA devInfo;
    devInfo.cbSize=sizeof devInfo;
    for (UINT i=0; SetupDiEnumDeviceInfo(devs,i,&devInfo); i++) {
     HKEY hKey;
     TCHAR s[16];
     DWORD slen=sizeof s;
     *s=0;
     if ((hKey=SetupDiOpenDevRegKey(devs,&devInfo,DICS_FLAG_GLOBAL,0,DIREG_DEV,KEY_READ))
       ==INVALID_HANDLE_VALUE) continue;
     RegQueryValueEx(hKey,T("PortName"),NULL,NULL,(LPBYTE)s,&slen);
     RegCloseKey(hKey);
     if (*s=='C') {	// Fehlschlge und LPTx ausfiltern
      int idx=ComboBox_AddString(hCombo,s);
      int num=StrToInt(s+3)-1;	// nullbasiert
      ComboBox_SetItemData(hCombo,idx,num);
      if (num==Config.SerialNo) ComboBox_SetCurSel(hCombo,idx);
     }
    }
    SetupDiDestroyDeviceInfoList(devs);
   }
  }break;

  case WM_CLOSE: {
   WINDOWPLACEMENT wp;
   wp.length=sizeof wp;
   GetWindowPlacement(Wnd,&wp);
   Config.WinPos.x=(short)wp.rcNormalPosition.left;
   Config.WinPos.y=(short)wp.rcNormalPosition.top;
   SaveConfig();
  }break;

  case WM_ENDSESSION: if (wParam) SendMessage(Wnd,WM_CLOSE,0,0); break;

 }
 return FALSE;
}

static HDDEDATA DdeCallback(UINT uType,UINT uFmt,HCONV,
  HSZ,HSZ hsz2,HDDEDATA hData,ULONG_PTR,ULONG_PTR) {
 HDDEDATA ret=DDE_FNOTPROCESSED;
 union{
  char a[20];
  WCHAR w[10];
  BYTE b[20];
 }s;
 int len=0;
 switch (uType) {
  case XTYP_CONNECT: ret=(HDDEDATA)TRUE;
  break;
  case XTYP_WILDCONNECT: {		// Automatische Enumeration durch Logger
   HSZ pairs[3]={hszService,hszService};
   ret=DdeCreateDataHandle(gDdeInst,(BYTE*)pairs,sizeof pairs,0,0,0,0);
  }break;
  case XTYP_ADVSTART: if (uFmt==CF_TEXT || uFmt==CF_UNICODETEXT) ret=(HDDEDATA) true;
  break;
  case XTYP_ADVREQ:
  case XTYP_REQUEST: {
   switch (uFmt) {
    case CF_TEXT: len=wnsprintfA(s.a,elemof(s.a),"%u",Config.Relays)+1; break;
    case CF_UNICODETEXT: len=(wnsprintfW(s.w,elemof(s.w),L"%u",Config.Relays)+1)<<1; break;
   }
   if (len) ret=DdeCreateDataHandle(gDdeInst,s.b,len,0,hsz2,uFmt,0);
  }break;
  case XTYP_POKE: {
   BOOL ok=FALSE;
   DdeGetData(hData,s.b,sizeof s.b,0);
   switch (uFmt) {
    case CF_TEXT: ok=StrToIntExA(s.a,STIF_SUPPORT_HEX,&len); break;
    case CF_UNICODETEXT: ok=StrToIntExW(s.w,STIF_SUPPORT_HEX,&len); break;
   }
   if (ok) {
    Config.Relays=(BYTE)len;
    SetCheckboxGroup(hMainWnd,16,23,Config.Relays);
    DdePostAdvise(gDdeInst,0,0);
    SwitchRelays();
    ret=(HDDEDATA)DDE_FACK;
   }
  }break;
 }
 return ret;
}

void CALLBACK WinMainCRTStartup() {
 hInstance=GetModuleHandle(NULL);
 InitCommonControls();
 DdeInitialize(&gDdeInst,DdeCallback,APPCLASS_STANDARD
   |CBF_FAIL_EXECUTES
   |CBF_SKIP_CONNECT_CONFIRMS|CBF_SKIP_REGISTRATIONS
   |CBF_SKIP_DISCONNECTS|CBF_SKIP_UNREGISTRATIONS,0);
 hszService=DdeCreateStringHandle(gDdeInst,T("APCDDE"),CP_WINNEUTRAL);
 DdeNameService(gDdeInst,hszService,0,DNS_REGISTER|DNS_FILTERON);
 int ec=DialogBox(hInstance,MAKEINTRESOURCE(100),0,MainDlgProc);
 DdeFreeStringHandle(gDdeInst,hszService);
 DdeUninitialize(gDdeInst);
 ExitProcess(ec);
}
